program Ali_Baba_v32_sans_unites;

uses crt,graph;

(* les variables terminant par temp sont des variables locales *)
(* les variables terminant par Par sont des paramtres *)
(* toutes les autres sont des variables globales *)

type
    tAnim = array[false..true] of byte;

const Speed    = 100; (* modifier cette variable suivant la vitesse *)
      xmaxLvl  = 14; (* numro de la coord max en x *)
      ymaxLvl  = 14; (* numro de la coord max en y *)
      MaxLevel = 11; (* dernier niveau cr *)
      sGround  = 0; (* sol *)
      sChest   = 5; (* coffres *)
      sTrap    : array[0..2] of byte = (6,13,14);  (* pieges *)
      sTrapAli : tAnim = (12,16);
      sGuard   : array[0..1] of tAnim = ((7,17),(8,18));
      sAli     : tAnim = (9,19); (* Ali Baba *)
      sMenu    = 10; (* menus *)
      sTour    = 11; (* cartouche *)
      sMort    = 15; (* ali est mort *)
      kUp      = 72; (* touche haut *)
      kLeft    = 75; (* touche gauche *)
      kRight   = 77; (* touche droite *)
      kDown    = 80; (* touche bas *)
      kF3      = 61; (* touche F3 *)
      kF7      = 65; (* touche F7 *)
      kF8      = 66; (* touche F8 *)
      kF9      = 67; (* touche F9 *)
      kF10     = 68; (* touche F10 *)
      kEsc     = 27; (* touche Esc *)
      kExt     = 0;  (* caractre tendu *)
      dEasy    = 0;  (* niveau facile *)
      dNorm    = 1;  (* niveau normal *)
      dHard    = 2;  (* niveau difficile *)
      cDiff : array[0..2] of string[10] = ('Facile','Normal','Difficile');
      s32x32   = 518; (* taille d'un sprite en mmoire *)
      FicSpr   = 'ALIBABA.SPR'; (* fichier des sprites *)
      FicLvl   = 'ALIBABA.LVL'; (* fichiers des niveaux *)
      FicScr   = 'ALIBABA.SCR'; (* fichiers des scores *)
      DirBGI   = ''; (* chemin des fichiers BGI *)

type tLevel  = array[0..xmaxLvl,0..ymaxLvl] of byte; (* niveau courant *)
     tNGuard = array[0..1] of byte; (* nb de gardes *)
     tCoord  = record
                 x,y : byte;
               end;
     tGuy    = record
                 new : tCoord; (* nouvelles coordonnees *)
                 old : tCoord; (* anciennes coordonnees *)
                 mvt : boolean; (* deux mouvements possibles *)
               end;
     tSpr    = array[0..19] of pointer;
     tScore  = record
                 Nom   : string[10];
                 Score : longint;
               end;
     tScores = array[0..4] of tScore; (* num joueur *)

var
    pSpr        : tSpr; (* pointeurs sur sprites *)
    Nom         : string; (* nom du joueur *)
    Scores      : tScores; (* scores *)
    Diff        : byte; (* difficult *)
    Lives       : byte; (* nb de vies *)
    Gold        : longint; (* score d'ali *)
    Voeux       : byte; (* nb de voeux *)
    isDead      : boolean; (* personne ne peut bouger *)
    isTrapped   : boolean; (* ali ne peut plus bouger *)
    Freeze      : boolean; (* les gardes sont gels *)
    quitte      : boolean; (* revient au menu *)
    jeu         : boolean; (* quitte le jeu *)
    Level       : tLevel; (* niveau courant *)
    Ali         : tGuy; (* ali *)
    Guard       : array[0..1,0..9] of tGuy; (* gardes *)
    nChest      : byte; (* nb de coffres *)
    nChestOpen  : byte; (* nb de coffres ouverts *)
    nTrap       : byte; (* nb de piges *)
    nGuards     : byte; (* nb de gardes *)
    nGuard      : tnGuard; (* nb de gardes de chaque type *)
    FreezeTime  : longint; (* temps que les gardes restent gels *)
    NumLevel    : byte; (* numro du niveau *)


(* fonction pour la procdure str OK *)
function stri(iPar:longint):string;
var strtemp : string;
begin
  str(iPar,strtemp);
  stri:=strtemp;
end;

(* affiche une chaine de caractres OK *)
procedure Ecrire(xPar,yPar,cPar:byte;strPar:string);
var xtemp, ytemp : word;
begin
  xtemp:=xPar * 32 + 16;
  ytemp:=yPar * 32 + 8;
  settextstyle(SmallFont,HorizDir,4);
  setcolor(Black);
  outtextxy(xtemp+1,ytemp+1,strPar);
  outtextxy(xtemp+1,ytemp-1,strPar);
  outtextxy(xtemp-1,ytemp-1,strPar);
  outtextxy(xtemp-1,ytemp+1,strPar);
  setcolor(cPar);
  outtextxy(xtemp,ytemp,strPar);
end;

(* affiche une chaine de caractres en gros OK *)
procedure Ecrireg(xPar,yPar:word;cPar,sPar:byte;strPar:string);
var xtemp, ytemp : word;
begin
  xtemp:=xPar * 16;
  ytemp:=yPar * 16;
  settextstyle(GothicFont,HorizDir,sPar);
  setcolor(cPar);
  outtextxy(xtemp,ytemp,strPar);
end;

(* affiche un sprite OK *)
procedure Draw(xPar,yPar,nPar:byte);
begin
  PutImage(xPar * 32, yPar * 32, pSpr[nPar]^, NormalPut);
end;

(* initialise le mode VGA 640x480x16 OK *)
procedure InitVGA;
var pilote, mode : integer;
begin
  pilote:=vga;
  mode:=vgahi;
  Initgraph(pilote,mode,DirBGI);
end;

(* lit les sprites d'un fichier OK *)
procedure LoadSprites;
var  itemp : byte;
     ftemp : file;
begin
  assign(ftemp,FicSpr);
  reset(ftemp,1);
  for itemp:=0 to 19 do
    begin
      GetMem(pSpr[itemp],s32x32);
      blockread(ftemp,pSpr[itemp]^,s32x32);
    end;
  close(ftemp);
end;

(* libre l'espace mmoire occup par les sprites OK *)
procedure KillSprites;
var itemp : byte;
begin
  for itemp:=0 to 19 do FreeMem(pSpr[itemp],s32x32);
end;

(* retourne au mode texte OK *)
procedure InitTxt;
begin
  closegraph;
end;

(* vide le tampon du clavier OK *)
procedure FreeBuffer;
var keytemp : char;
begin
  while KeyPressed do keytemp:=ReadKey;
end;

(* affiche le cartouche OK *)
procedure DrawBackgrnd;
var ytemp   : byte;
    xtemp   : byte;
    strtemp : string[4];
begin
  for ytemp:=0 to 14 do
    for xtemp:=15 to 19 do
    draw(xtemp,ytemp,11);
  Ecrire(15,2,15,'Or : '+stri(Gold));
  Ecrire(15,3,15,'Voeux : '+stri(Voeux));
  Ecrire(15,4,15,'Vies : '+stri(Lives));
  Ecrire(15,5,15,'Niveau : '+stri(numLevel+1));
  Ecrire(15,6,15,'Difficulte : '+cDiff[Diff]);
  Ecrire(15,10,15,'F3 : Faire un voeu');
  Ecrire(15,11,15,'ESC : Arreter la partie');
  settextstyle(DefaultFont,HorizDir,0);
  setcolor(Black);
  strtemp:=chr(27)+chr(24)+chr(26)+chr(25);
  outtextxy(495,395,strtemp);
  outtextxy(497,395,strtemp);
  outtextxy(495,397,strtemp);
  outtextxy(497,397,strtemp);
  setcolor(White);
  outtextxy(496,396,strtemp);
  Ecrire(16,12,15,' : Deplacement');
end;

(* attend l'appuie d'une touche OK *)
procedure Pause;
begin
  FreeBuffer;
  repeat
  until Keypressed;
  FreeBuffer;
end;

(* change deux octets OK *)
procedure Change(var xPar,yPar : byte);
var auxtemp : byte;
begin
  auxtemp:=xPar;
  xPar:=yPar;
  yPar:=auxtemp;
end;

(* copie des coordonnes OK *)
procedure CopyCoord(oldPar : tCoord; var newPar : tCoord);
begin
  newPar.x:=oldPar.x;
  newPar.y:=oldPar.y;
end;

(* retrace un sprite sur l'cran et ds la matrice OK *)
procedure Retrace(xPar,yPar,sPar:byte);
begin
  Draw(xPar,yPar,sPar);
  Level[xPar,yPar]:=sPar;
end;

(* dplace un personnage OK *)
procedure MoveGuy(var gPar:tGuy; sPar:tAnim);
begin
  gPar.mvt := not gPar.mvt;
  Retrace(gPar.new.x,gPar.new.y,sPar[gPar.mvt]);
  Retrace(gPar.old.x,gPar.old.y,sGround);
end;

(* le joueur gagne au niveau OK *)
procedure Gagne;
var keytemp   : char;
    xtemp     : byte;
    bonustemp : longint;
begin
  if NumLevel<MaxLevel then
    begin
      for xtemp:=6 to 9 do draw(xtemp,7,sMenu);
      Ecrire(6,7,15,'Vous avez gagne !');
      inc(NumLevel);
    end
  else
    begin
      for xtemp:=4 to 11 do
        begin
          draw(xtemp,7,sMenu);
          draw(xtemp,8,sMenu);
        end;
      bonustemp:=(500*Diff)+(1000*Lives);
      inc(gold,bonustemp);
      inc(lives);
      ecrire(4,7,15,'Vous avez gagne au niveau '+cDiff[Diff]);
      ecrire(4,8,15,'ainsi que '+stri(bonustemp)+' pieces d''or et 1 vie');
      for xtemp:=15 to 19 do draw(xtemp,2,sTour);
      Ecrire(15,2,15,'Or : '+ stri(Gold));
      numLevel:=0;
      if Diff<2 then inc(Diff);
    end;
  isDead:=true;
  Pause;
end;

(* augmente le score OK *)
procedure AddGold;
var xtemp : byte;
begin
  MoveGuy(Ali,sAli);
  for xtemp:=15 to 19 do Draw(xtemp,2,sTour);
  inc(Gold,random(500+Diff*500) + 1);
  Ecrire(15,2,15,'Or : '+ stri(Gold));
  inc(nChestOpen);
  if nChestOpen >= (nChest+1) then Gagne;
end;

(* ali est mort OK *)
procedure MortAli(xPar,yPar:byte);
var xtemp : byte;
begin
  MoveGuy(Ali,sAli);
  draw(xPar,yPar,sMort);
  for xtemp:=5 to 8 do draw(xtemp,7,sMenu);
  Ecrire(5,7,15,'Vous avez perdu !');
  isTrapped:=true;
  isDead:=true;
  if Lives<=0 then
    quitte:=true
  else
    begin
      dec(Lives);
      for xtemp:=15 to 18 do Draw(xtemp,4,sTour);
      Ecrire(15,4,15,'Vies : '+stri(Lives));
    end;
  Pause;
end;

(* ali tombe dans un pige OK *)
procedure TrapAli(xPar,yPar:byte);
begin
  MoveGuy(Ali,sTrapAli);
  delay(Speed*2);
  draw(xPar,yPar,sTrap[1]);
  delay(Speed*4);
  draw(xPar,yPar,sTrap[2]);
  Level[xPar,yPar]:=sTrap[2];
  isTrapped:=true;
  if voeux<1 then MortAli(xPar,yPar);
end;

(* vrifie ce que contient la case OK *)
procedure TestAli;
begin
  case Level[Ali.new.x,Ali.new.y] of
     0 : MoveGuy(Ali,sAli);
  1..4 : CopyCoord(Ali.old,Ali.new);
     5 : AddGold;
     6 : TrapAli(Ali.new.x,Ali.new.y);
  else MortAli(Ali.new.x,Ali.new.y);
  end;
end;

(* dplacements possibles pour Ali *)

(* vers le haut OK *)
procedure MoveAliUp;
begin
  if Ali.new.y > 0 then
    begin
      Ali.old:=Ali.new;
      dec(Ali.new.y);
      TestAli;
    end;
end;

(* vers le bas OK *)
procedure MoveAliDown;
begin
  if Ali.new.y < ymaxLvl then
    begin
      Ali.old:=Ali.new;
      inc(Ali.new.y);
      TestAli;
    end;
end;

(* vers la gauche OK *)
procedure MoveAliLeft;
begin
  if Ali.new.x > 0 then
    begin
      Ali.old:=Ali.new;
      dec(Ali.new.x);
      TestAli;
    end;
end;

(* vers la droite OK *)
procedure MoveAliRight;
begin
  if Ali.new.x < xmaxLvl then
    begin
      Ali.old:=Ali.new;
      inc(Ali.new.x);
      TestAli;
    end;
end;

(* dplacements d'Ali OK *)
procedure MoveAli(keyPar:byte);
begin
  case keyPar of
     kUp : MoveAliUp;
   kLeft : MoveAliLeft;
  kRight : MoveAliRight;
   kDown : MoveAliDown;
  end;
end;

(* change les anciennes coordonnes et les nouvelles OK *)
procedure ChangeCoord(var cPar:tGuy);
begin
  Change(cPar.new.x,cPar.old.x);
  Change(cPar.new.y,cPar.old.y);
end;

(* vrifie ce que contient la case  la position du garde OK *)
procedure TestGuard(TypePar,nPar:byte);
begin
  case Level[Guard[TypePar,nPar].new.x,Guard[TypePar,nPar].new.y] of
     0 : MoveGuy(Guard[TypePar,nPar],sGuard[TypePar]);
  9,19 : MortAli(Ali.new.x,Ali.new.y);
  else ChangeCoord(Guard[TypePar,nPar]);
  end;
end;

(* vers le bas OK *)
procedure MoveGuardDown(nPar:byte);
begin
  if Guard[0,nPar].new.y < ymaxLvl then
    begin
      Guard[0,nPar].old:=Guard[0,nPar].new;
      inc(Guard[0,nPar].new.y);
      TestGuard(0,nPar);
    end
  else
    begin
      Guard[0,nPar].old:=Guard[0,nPar].new;
      dec(Guard[0,nPar].new.y);
      TestGuard(0,nPar);
    end;
end;

(* vers le haut OK *)
procedure MoveGuardUp(nPar:byte);
begin
  if Guard[0,nPar].new.y > 0 then
    begin
      Guard[0,nPar].old:=Guard[0,nPar].new;
      dec(Guard[0,nPar].new.y);
      TestGuard(0,nPar);
    end
  else
    begin
      Guard[0,nPar].old:=Guard[0,nPar].new;
      inc(Guard[0,nPar].new.y);
      TestGuard(0,nPar);
    end;
end;

(* vers la gauche OK *)
procedure MoveGuardLeft(nPar:byte);
begin
  if Guard[1,nPar].new.x > 0 then
    begin
      Guard[1,nPar].old:=Guard[1,nPar].new;
      dec(Guard[1,nPar].new.x);
      TestGuard(1,nPar);
    end
  else
    begin
      Guard[1,nPar].old:=Guard[1,nPar].new;
      inc(Guard[1,nPar].new.x);
      TestGuard(1,nPar);
    end;
end;

(* vers la droite OK *)
procedure MoveGuardRight(nPar:byte);
begin
  if Guard[1,nPar].new.x < xmaxLvl then
    begin
      Guard[1,nPar].old:=Guard[1,nPar].new;
      inc(Guard[1,nPar].new.x);
      TestGuard(1,nPar);
    end
  else
    begin
      Guard[1,nPar].old:=Guard[1,nPar].new;
      dec(Guard[1,nPar].new.x);
      TestGuard(1,nPar);
    end;
end;

(* dplacements des gardes OK *)
procedure MoveGuard(typePar,nPar:byte;sensPar:integer);
begin
  case typePar of
    0 : case sensPar of
         -1 : MoveGuardDown(nPar);
          1 : MoveGuardUp(nPar);
        end;
    1 : case sensPar of
         -1 : MoveGuardRight(nPar);
          1 : MoveGuardLeft(nPar);
        end;
  end;
end;

(* affiche le niveau OK *)
procedure DrawLevel;
var xtemp, ytemp : byte;
begin
  for ytemp:=0 to ymaxLvl do
    for xtemp:=0 to xmaxLvl do
      Draw(xtemp,ytemp,Level[xtemp,ytemp]);
end;

(* charge le niveau spcifi dans la mmoire OK *)
procedure LoadLevel(numtemp:byte);
var htemp   : file of tLevel;
    errtemp : integer;
begin
  assign(htemp,FicLvl);
  {$I-}
  Reset(htemp);
  {$I+}
  errtemp:=IOResult;
  if errtemp=0 then
    begin
      seek(htemp,numtemp);
      read(htemp,Level);
      close(htemp);
    end
  else
    begin
      writeln('Erreur lors de l''ouverture du fichier'+FicLvl);
      halt;
    end;
end;

(* initialise un objet OK *)
procedure Create(sPar,maxPar:byte);
var itemp, xtemp, ytemp : byte;
begin
  for itemp:=0 to maxPar do
    begin
      repeat
        xtemp:=random(15);
        ytemp:=random(15);
      until Level[xtemp,ytemp]=0;
      Level[xtemp,ytemp]:=sPar;
    end;
end;

(* initialise les coordonnes des gardes OK *)
procedure CreateGuards;
var itemp, jtemp : byte;
    xtemp, ytemp : byte;
    mvttemp      : boolean;
    Freetemp     : integer;
begin
  for jtemp:=0 to 1 do
    for itemp:=0 to nGuard[jtemp] do
      begin
        repeat
          xtemp:=random(13)+1;
          ytemp:=random(13)+1;
          Freetemp:=Level[xtemp,ytemp];
          inc(Freetemp,Level[xtemp-1,ytemp]);
          inc(Freetemp,Level[xtemp+1,ytemp]);
          inc(Freetemp,Level[xtemp,ytemp-1]);
          inc(Freetemp,Level[xtemp,ytemp+1]);
        until Freetemp=0;
        case random(2) of
         0 : begin
               mvttemp:=false;
               Guard[jtemp,itemp].old.x:=xtemp+jtemp;
               Guard[jtemp,itemp].old.y:=ytemp-jtemp+1;
             end;
         1 : begin
               mvttemp:=true;
               Guard[jtemp,itemp].old.x:=xtemp-jtemp;
               Guard[jtemp,itemp].old.y:=ytemp+jtemp-1;
             end;
        end;
        Level[xtemp,ytemp]:=sGuard[jtemp,mvttemp];
        Guard[jtemp,itemp].new.x:=xtemp;
        Guard[jtemp,itemp].new.y:=ytemp;
      end;
end;

(* initialise les coordonnes d'ali OK *)
procedure CreateAli;
var xtemp, ytemp : byte;
    mvttemp      : boolean;
begin
  xtemp:=0;
  ytemp:=0;
  case random(2) of
    0 : mvttemp:=false;
    1 : mvttemp:=true;
  end;
  Level[xtemp,ytemp]:=sAli[mvttemp];
  Ali.new.x:=xtemp;
  Ali.new.y:=ytemp;
  CopyCoord(Ali.new,Ali.old);
end;

(* ali fait un voeu OK *)
procedure FaireVoeu;
var itemp, jtemp : byte;
begin
  if voeux > 0 then
    begin
      for jtemp:=6 to 7 do
        for itemp:=4 to 8 do
          draw(itemp,jtemp,sMenu);
      Ecrire(4,6,15,'1 - Sortir d''un piege');
      Ecrire(4,7,15,'2 - Geler les gardes');
      case readkey of
        '1' : if isTrapped then
                begin
                  isTrapped:=false;
                  MoveGuy(Ali,sAli);
                  dec(voeux);
                end;
        '2' :   begin
                  if Freeze then
                    FreezeTime:=FreezeTime-100000
                  else
                    FreezeTime:=0;
                  Freeze:=true;
                  dec(voeux);
                end;
      end;
      for itemp:=15 to 19 do Draw(itemp,3,11);
      Ecrire(15,3,15,'Voeux : '+ stri(voeux));
    end
  else
    begin
      for itemp:=4 to 9 do
        draw(itemp,7,sMenu);
      ecrire(4,7,15,'Vous n''avez plus de voeux');
      Pause;
    end;
  DrawLevel;
end;

(* le joueur a appuy sur ESC OK *)
procedure Quitter;
var keytemp : char;
    xtemp   : byte;
begin
  for xtemp:=3 to 10 do draw(xtemp,7,sMenu);
  Ecrire(3,7,15,'Voulez-vous vraiment quitter ? (o/n)');
  keytemp := readkey;
  if keytemp = 'o' then
    begin
      isDead:=true;
      Quitte := true;
    end
  else
    begin
      Quitte := false;
      DrawLevel;
    end;
end;

(* teste l'appuie d'une touche et
renvoie  la procdure correspondante OK *)
procedure TestKey;
var keytemp, xtemp : byte;
begin
  if keypressed then
    begin
      keytemp:=ord(readkey);
      case keytemp of
        kExt: begin
                keytemp:=ord(readkey);
                case keytemp of
                 kF3  : FaireVoeu;
                 kF7  : begin
                          for xtemp:=15 to 19 do Draw(xtemp,2,sTour);
                          inc(Gold,random(500+Diff*500) + 1);
                          Ecrire(15,2,15,'Or : '+ stri(Gold));
                        end;
                 kF8  : begin
                          for xtemp:=15 to 19 do Draw(xtemp,3,sTour);
                          inc(Voeux);
                          Ecrire(15,3,15,'Voeux : '+stri(Voeux));
                        end;
                 kF9  : begin
                          for xtemp:=15 to 19 do Draw(xtemp,4,sTour);
                          inc(Lives);
                          Ecrire(15,4,15,'Vies : '+stri(Lives));
                        end;
                 kF10 : Gagne;
                else if not isTrapped then MoveAli(keytemp);
                end;
              end;
        kEsc: Quitter;
      end;
      FreeBuffer;
    end;
end;

(* dplace les gardes et fait tous les tests OK *)
procedure Main;
var itemp, jtemp : byte;
    senstemp     : shortint;
begin
  for jtemp:=0 to 1 do
    for itemp:=0 to nGuard[jtemp] do
      if not isDead then
        begin
          TestKey;
          if freeze then
            begin
              inc(FreezeTime);
              if FreezeTime > (Speed * 100) then Freeze:=false;
            end
          else if ( not quitte ) and ( not isDead ) then
                 begin
                   delay(Speed div (nGuard[jtemp]+1));
                   case jtemp of
                     0: senstemp:=Guard[0,itemp].old.y-Guard[0,itemp].new.y;
                     1: senstemp:=Guard[1,itemp].old.x-Guard[1,itemp].new.x;
                   end;
                   case random(20-Diff) of
                      0 : MoveGuard(jtemp,itemp,-senstemp);
                     else MoveGuard(jtemp,itemp,senstemp);
                   end;
                 end;
        end;
end;

(* initialise toutes les variables dont les positions OK *)
procedure InitialiseVar;
begin
  randomize;
  quitte:=false;
  isDead:=false;
  isTrapped:=false;
  Freeze:=false;
  nGuards:=(NumLevel div 2)+Diff*2;
  nGuard[0]:=nGuards div 2;
  nGuard[1]:=nGuards-nGuard[0];
  nTrap:=(NumLevel div 2)+Diff;
  nChest:=NumLevel+3;
  nChestOpen:=0;
  voeux:=3;
  CreateAli;
  CreateGuards;
  Create(sChest,nChest);
  Create(sTrap[0],nTrap);
end;

(* charge les scores dans la mmoire OK *)
procedure LoadScores;
var htemp     : file of tScores;
    errtemp   : integer;
    itemp     : longint;
begin
  assign(htemp,FicScr);
  {$I-}
  Reset(htemp);
  {$I+}
  errtemp:=IOResult;
  if errtemp=0 then
    begin
      reset(htemp);
      read(htemp,Scores);
      close(htemp);
    end
  else if errtemp=2 then
    begin
      Rewrite(htemp);
      for itemp:=0 to 4 do
        begin
          Scores[itemp].Nom:='Anonyme   ';
          Scores[itemp].Score:=20000*(5-itemp);
        end;
      write(htemp,Scores);
      close(htemp);
    end
  else
    begin
      InitTxt;
      writeln('Erreur lors de l''ouverture du fichier'+FicScr);
      halt;
    end;
end;

(* demande le nom du joueur OK *)
procedure MenuNom(var nomPar:string);
var
  nomtemp  : string[10];
  xtemp    : byte;
  keytemp  : byte;
  ftemp    : byte;
begin
  ftemp:=blue;
  nomtemp:='          ';
  nomPar:=nomtemp;
  xtemp:=0;
  ecrireg(6,4,Yellow,2,'Quel est votre nom ? (10 caracteres maximum)');
  repeat
    repeat
    until Keypressed;
    keytemp:=ord(readkey);
    FreeBuffer;
    if (keytemp=8) and (xtemp>0) then
      begin
        ecrireg(10,6,ftemp,6,nomtemp);
        nomtemp[xtemp]:=' ';
        ecrireg(10,6,Yellow,6,nomtemp);
        xtemp:=xtemp-1;
      end
    else if (keytemp>=32) and (keytemp<=ord('z')) and (xtemp<10) then
           begin
             xtemp:=xtemp+1;
             nomtemp[xtemp]:=chr(keytemp);
             ecrireg(10,6,Yellow,6,nomtemp);
           end;
  until keytemp=13;
  nomPar:=nomtemp;
end;

(* range le score du joueur ds la table des scores OK *)
procedure WriteScore(nomPar:string;GoldPar:longint);
var htemp      : file of tScores;
    errtemp    : integer;
    itemp      : byte;
    jtemp      : byte;
    trouvetemp : boolean;
begin
  assign(htemp,FicScr);
  {$I-}
  Reset(htemp);
  {$I+}
  errtemp:=IOResult;
  if errtemp=0 then
    begin
      itemp:=0;
      trouvetemp:=false;
      repeat
        if  GoldPar > Scores[itemp].Score then
          begin
            for jtemp:=3 downto itemp do
              Scores[jtemp+1]:=Scores[jtemp];
            trouvetemp:=true;
          end
        else
          inc(itemp);
      until trouvetemp or ( itemp > 4);
      if trouvetemp then
        begin
          MenuNom(Nom);
          Scores[itemp].Nom:=Nom;
          Scores[itemp].Score:=GoldPar;
          rewrite(htemp);
          write(htemp,Scores);
        end;
      close(htemp);
    end
  else
    begin
      InitTxt;
      writeln('Erreur lors de l''ouverture du fichier'+FicScr);
      halt;
    end;
end;

(* change la couleur de fond OK *)
procedure Fade(cPar:byte);
var itemp : word;
begin
  setcolor(cPar);
  for itemp:=0 to 639 do
      line(itemp,0,639-itemp,479);
  for itemp:=479 downto 0 do
      line(0,itemp,639,479-itemp);
end;

(* affiche les scores OK *)
procedure ShowScores;
var itemp : byte;
begin
  ecrireg(12,1,LightBlue,4,'Table des Scores');
  for itemp:=0 to 4 do
    begin
      ecrireg(1,itemp*3+10,White,4,Scores[itemp].Nom);
      ecrireg(30,itemp*3+10,White,4,stri(Scores[itemp].Score));
    end;
end;

(* affiche les crdits OK *)
procedure Intro;
begin
  fade(blue);
  ecrireg(10,6,Black,5,'Frank BARDELLI');
  ecrireg(19,11,Black,5,'et');
  ecrireg(13,16,Black,5,'Cedric OCHS');
  ecrireg(15,21,Black,5,'presentent');
  ecrireg(9,5,White,5,'Frank BARDELLI');
  ecrireg(18,10,White,5,'et');
  ecrireg(12,15,White,5,'Cedric OCHS');
  ecrireg(14,20,White,5,'presentent');
  delay(Speed*20);
end;

(* raffiche les crdits *)
procedure Credits;
begin
  writeln('Projet d''Informatique 1997/98 de MIAS 1re anne');
  writeln('Ralis par Frank BARDELLI et Cdric OCHS du groupe de TD n5');
  writeln('(c) 1998 Dark Legend Software');
end;

(* affiche le menu jouer/quitter OK *)
procedure MenuJouer(var menuPar : boolean);
var
  quittemp : boolean;
  keytemp  : byte;
  menutemp : boolean;
begin
  fade(LightBlue);
  ecrireg(7,3,Blue,8,'ALi-BABA');
  ecrireg(6,2,White,8,'ALi-BABA');
  ecrireg(17,15,Blue,4,'Jouer');
  ecrireg(17,18,Blue,4,'Quitter');
  menutemp:=true;
  ecrireg(14,9,White,10,'.');
  quittemp:=false;
  repeat
    keytemp:=ord(readkey);
    FreeBuffer;
    if keytemp<>13 then
      if menutemp then
        begin
          menutemp:=false;
          ecrireg(14,9,LightBlue,10,'.');
          ecrireg(14,12,White,10,'.');
        end
      else
        begin
          menutemp:=true;
          ecrireg(14,9,White,10,'.');
          ecrireg(14,12,LightBlue,10,'.');
        end
    else
      quittemp:=true;
  until quittemp;
  menuPar:=menutemp;
end;

(* affiche le menu choix de difficult OK *)
procedure MenuDiff(var diffPar:byte);
var
  quittemp : boolean;
  keytemp  : byte;
  menutemp : byte;
begin
  fade(Blue);
  menutemp:=1;
  ecrireg(15,12,LightBlue,2,'Niveau de difficulte ?');
  ecrireg(17,15,White,4,'Facile');
  ecrireg(17,18,White,4,'Normal');
  ecrireg(17,21,White,4,'Difficile');
  ecrireg(14,12,White,10,'.');
  quittemp:=false;
  repeat
    keytemp:=ord(readkey);
    if keytemp=0 then
      begin
        keytemp:=ord(readkey);
        case keytemp of
          kUp   : if menutemp > 0 then dec(menutemp);
          kDown : if menutemp < 2 then inc(menutemp);
        end;
      end
    else if keytemp=13 then quittemp:=true;
    FreeBuffer;
    case menutemp of
      0 : begin
            ecrireg(14,9,White,10,'.');
            ecrireg(14,12,Blue,10,'.');
            ecrireg(14,15,Blue,10,'.');
          end;
      1 : begin
            ecrireg(14,9,Blue,10,'.');
            ecrireg(14,12,White,10,'.');
            ecrireg(14,15,Blue,10,'.');
          end;
      2 : begin
            ecrireg(14,9,Blue,10,'.');
            ecrireg(14,12,Blue,10,'.');
            ecrireg(14,15,White,10,'.');
          end;
    end;
  until quittemp;
  diffPar:=menutemp;
end;

begin
  LoadScores;
  LoadSprites;
  InitVGA;
  Intro;
  repeat
  MenuJouer(jeu);
  if jeu then
    begin
      MenuDiff(Diff);
      Lives:=3;
      Gold:=0;
      NumLevel:=0;
      repeat
        fade(Black);
        LoadLevel(NumLevel);
        InitialiseVar;
        DrawLevel;
        DrawBackgrnd;
        Repeat
          Main;
        until isDead;
      until quitte;
      fade(Blue);
      WriteScore(Nom,Gold);
      ShowScores;
      Pause;
    end;
  until not jeu;
  fade(Black);
  KillSprites;
  InitTxt;
  Credits;
end.
