unit GFX;

interface

uses graph,gen;

procedure Ecrire(xPar,yPar,cPar:byte;strPar:string);
procedure Ecrireg(xPar,yPar:word;cPar,sPar:byte;strPar:string);
procedure Draw(xPar,yPar,nPar:byte);
procedure InitVGA;
procedure InitTxt;
procedure Fade(cPar:byte);
procedure LoadSprites;
procedure KillSprites;
procedure DrawBackgrnd;

implementation

const
      DirBGI   = 'b:'; (* chemin des fichiers BGI *)
      FicSpr   = 'b:ALIBABA.SPR'; (* fichier des sprites *)
      s32x32   = 518; (* taille d'un sprite en mmoire *)

type
     tSpr        = array[0..19] of pointer;

var
     pSpr        : tSpr; (* pointeurs sur sprites *)

(* lit les sprites d'un fichier OK *)
procedure LoadSprites;
var  itemp : byte;
     ftemp : file;
begin
  assign(ftemp,FicSpr);
  reset(ftemp,1);
  for itemp:=0 to 19 do
    begin
      GetMem(pSpr[itemp],s32x32);
      blockread(ftemp,pSpr[itemp]^,s32x32);
    end;
  close(ftemp);
end;

(* libre l'espace mmoire occup par les sprites OK *)
procedure KillSprites;
var itemp : byte;
begin
  for itemp:=0 to 19 do FreeMem(pSpr[itemp],s32x32);
end;

(* affiche une chaine de caractres OK *)
procedure Ecrire(xPar,yPar,cPar:byte;strPar:string);
var xtemp, ytemp : word;
begin
  xtemp:=xPar * 32 + 16;
  ytemp:=yPar * 32 + 8;
  settextstyle(SmallFont,HorizDir,4);
  setcolor(Black);
  outtextxy(xtemp+1,ytemp+1,strPar);
  outtextxy(xtemp+1,ytemp-1,strPar);
  outtextxy(xtemp-1,ytemp-1,strPar);
  outtextxy(xtemp-1,ytemp+1,strPar);
  setcolor(cPar);
  outtextxy(xtemp,ytemp,strPar);
end;

(* affiche une chaine de caractres en gros OK *)
procedure Ecrireg(xPar,yPar:word;cPar,sPar:byte;strPar:string);
var xtemp, ytemp : word;
begin
  xtemp:=xPar * 16;
  ytemp:=yPar * 16;
  settextstyle(GothicFont,HorizDir,sPar);
  setcolor(cPar);
  outtextxy(xtemp,ytemp,strPar);
end;

(* affiche un sprite OK *)
procedure Draw(xPar,yPar,nPar:byte);
begin
  PutImage(xPar * 32, yPar * 32, pSpr[nPar]^, NormalPut);
end;

(* initialise le mode VGA 640x480x16 OK *)
procedure InitVGA;
var pilote, mode : integer;
begin
  pilote:=vga;
  mode:=vgahi;
  Initgraph(pilote,mode,DirBGI);
end;

(* retourne au mode texte OK *)
procedure InitTxt;
begin
  closegraph;
end;

(* affiche le cartouche OK *)
procedure DrawBackgrnd;
var ytemp   : byte;
    xtemp   : byte;
    strtemp : string[4];
begin
  for ytemp:=0 to 14 do
    for xtemp:=15 to 19 do
    draw(xtemp,ytemp,11);
  Ecrire(15,2,15,'Or : '+stri(Gold));
  Ecrire(15,3,15,'Voeux : '+stri(Voeux));
  Ecrire(15,4,15,'Vies : '+stri(Lives));
  Ecrire(15,5,15,'Niveau : '+stri(numLevel+1));
  Ecrire(15,6,15,'Difficulte : '+cDiff[Diff]);
  Ecrire(15,10,15,'F3 : Faire un voeu');
  Ecrire(15,11,15,'ESC : Arreter la partie');
  settextstyle(DefaultFont,HorizDir,0);
  setcolor(Black);
  strtemp:=chr(27)+chr(24)+chr(26)+chr(25);
  outtextxy(495,395,strtemp);
  outtextxy(497,395,strtemp);
  outtextxy(495,397,strtemp);
  outtextxy(497,397,strtemp);
  setcolor(White);
  outtextxy(496,396,strtemp);
  Ecrire(16,12,15,' : Deplacement');
end;

(* change la couleur de fond OK *)
procedure Fade(cPar:byte);
var itemp : word;
begin
  setcolor(cPar);
  for itemp:=0 to 639 do
      line(itemp,0,639-itemp,479);
  for itemp:=479 downto 0 do
      line(0,itemp,639,479-itemp);
end;

end.